<?php
class hikashopDiscountClass extends hikashopClass{
	var $tables = array('discount');
	var $pkeys = array('discount_id');
	var $namekeys = array('');
	var $toggle = array('discount_published'=>'discount_id');

	function saveForm(){
		$discount = new stdClass();
		$discount->discount_id = hikashop_getCID('discount_id');
		$formData = JRequest::getVar( 'data', array(), '', 'array' );
		foreach($formData['discount'] as $column => $value){
			hikashop_secureField($column);
			$discount->$column = strip_tags($value);
		}
		if(!empty($discount->discount_start)){
			$discount->discount_start=hikashop_getTime($discount->discount_start);
		}
		if(!empty($discount->discount_end)){
			$discount->discount_end=hikashop_getTime($discount->discount_end);
		}

		$status = $this->save($discount);
		if(!$status){
			JRequest::setVar( 'fail', $discount  );
			$app = JFactory::getApplication();
			$app->enqueueMessage(JText::_('DISCOUNT_CODE_ALREADY_USED'));
		}
		return $status;
	}

	function save(&$discount){
		if(empty($discount->discount_id)){
			//coupons need a code
			if(empty($discount->discount_type) || ($discount->discount_type=='coupon' && empty($discount->discount_code))){
				return false;
			}
		}

		//You don't want to keep extra spaces at the end!
		if(!empty($discount->discount_code)) $discount->discount_code = trim($discount->discount_code);

		$status = parent::save($discount);
		return $status;
	}

	function load($coupon){

		$do=true;
		JPluginHelper::importPlugin( 'hikashop' );
		$dispatcher = JDispatcher::getInstance();
		$item = $dispatcher->trigger( 'onBeforeCouponLoad', array( &$coupon, & $do) );
		if(!$do) return current($item);

		static $coupons = array();

		//We are cool guys, if the user copy/paste the coupon and added extra param, we just remove them
		$coupon = trim($coupon);
		if(!isset($coupons[$coupon])){
			$filters = array('discount_code='.$this->database->Quote($coupon),'discount_type=\'coupon\'','discount_published=1');
			$query = 'SELECT * FROM '.hikashop_table('discount').' WHERE '.implode(' AND ',$filters);
			$this->database->setQuery($query);
			$coupons[$coupon] = $this->database->loadObject();
		}
		return $coupons[$coupon];
	}

	function loadAndCheck($coupon_code,&$total,$zones,&$products,$display_error=true){
		$coupon = $this->load($coupon_code);
		return $this->check($coupon,$total,$zones,$products,$display_error);
	}

	function check(&$coupon,&$total,$zones,&$products,$display_error=true){

		JPluginHelper::importPlugin( 'hikashop' );
		$dispatcher = JDispatcher::getInstance();
		$error_message = '';
		$do=true;
		$dispatcher->trigger( 'onBeforeCouponCheck', array( &$coupon,&$total,&$zones,&$products,&$display_error, &$error_message, & $do) );
		if($do){
			$user = hikashop_get('class.user');
			$currency = hikashop_get('class.currency');
			if(empty($coupon)){
				$error_message = JText::_('COUPON_NOT_VALID');
			}elseif($coupon->discount_start>time()){
				$error_message = JText::_('COUPON_NOT_YET_USABLE');
			}elseif($coupon->discount_end && $coupon->discount_end<time()){
				$error_message = JText::_('COUPON_EXPIRED');
			}else{
				if(hikashop_level(2)){
					if(!empty($coupon->discount_access)){
						$my =& JFactory::getUser();
						if($coupon->discount_access != 'all' AND ($coupon->discount_access == 'none' OR empty($my->id) OR !hikashop_isAllowed($coupon->discount_access))){
								$error_message = JText::_('COUPON_NOT_FOR_YOU');
							}
					}
				}
				if(empty($error_message) && hikashop_level(1)){
					if(!empty($coupon->discount_quota) && $coupon->discount_quota<=$coupon->discount_used_times){
						$error_message = JText::_('QUOTA_REACHED_FOR_COUPON');
					}else{
						if(!empty($coupon->discount_quota_per_user)){
							$user_id = hikashop_loadUser();
							if($user_id){
								$db = JFactory::getDBO();
								$config =& hikashop_config();
								$cancelled_order_status = explode(',',$config->get('cancelled_order_status'));
								$cancelled_order_status = "'".implode("','",$cancelled_order_status)."'";
								$query = 'SELECT COUNT(order_id) AS already_used FROM '.hikashop_table('order').' WHERE order_user_id='.(int)$user_id.' AND order_status NOT IN ('.$cancelled_order_status.') AND order_discount_code='.$db->Quote($coupon->discount_code).' GROUP BY order_id';
								$db->setQuery($query);
								$already_used = $db->loadResult();
								if($coupon->discount_quota_per_user<=$already_used){
									$error_message = JText::_('QUOTA_REACHED_FOR_COUPON');
								}
							}
						}
						if(empty($error_message)){
							if($coupon->discount_zone_id){
								$class = hikashop_get('class.zone');
								$zone = $class->get($coupon->discount_zone_id);
								if(!in_array($zone->zone_namekey,$zones)){
									$error_message = JText::_('COUPON_NOT_AVAILABLE_IN_YOUR_ZONE');
								}
							}
						}
						$ids = array();
						$qty = 0;
						foreach($products as $prod){
							$qty+=$prod->cart_product_quantity;
							if(!empty($prod->product_parent_id)) $ids[$prod->product_parent_id]=$prod->product_parent_id;
							else $ids[$prod->product_id]=$prod->product_id;
						}
						if(empty($error_message) && $coupon->discount_product_id){
							if(!in_array($coupon->discount_product_id,$ids)){
								$error_message = JText::_('COUPON_NOT_FOR_THOSE_PRODUCTS');
							}
						}
						if(empty($error_message) && $coupon->discount_category_id){
							$database = JFactory::getDBO();
							if($coupon->discount_category_childs){
								$categoryClass = hikashop_get('class.category');
								$category = $categoryClass->get((int)$coupon->discount_category_id);
								$filters = array('b.category_left >= '.$category->category_left ,'b.category_right <= '.$category->category_right,'b.category_type=\'product\'','a.product_id IN ('.implode(',',$ids).')');
								hikashop_addACLFilters($filters,'category_access','b');
								$select = 'SELECT a.product_id FROM '.hikashop_table('category').' AS b LEFT JOIN '.hikashop_table('product_category').' AS a ON b.category_id=a.category_id WHERE '.implode(' AND ',$filters);
							}else{
								$filters = array('b.category_id = '.(int)$coupon->discount_category_id ,'a.product_id IN ('.implode(',',$ids).')');
								hikashop_addACLFilters($filters,'category_access','b');
								$select = 'SELECT a.product_id FROM '.hikashop_table('category').' AS b LEFT JOIN '.hikashop_table('product_category').' AS a ON b.category_id=a.category_id WHERE '.implode(' AND ',$filters);
							}

							$database->setQuery($select);
/********************/
/* Start BRAINFORGE */
/********************/
						// Changes for: 27448 Coupons for specific products
//						$id = $database->loadResult();
//						if(!$id){
							$id = $database->loadRowList();

							if (empty($id)) {
/******************/
/* End BRAINFORGE */
/******************/
								$error_message = JText::_('COUPON_NOT_FOR_PRODUCTS_IN_THOSE_CATEGORIES');
							}
						}
						if(empty($error_message) && bccomp($coupon->discount_minimum_order,0,5)){
							//a minimum order price is set for the coupon

							//convert the currency if needed
							$currency->convertCoupon($coupon,$total->prices[0]->price_currency_id);
							$config =& hikashop_config();
							$discount_before_tax = $config->get('discount_before_tax');
							$var = 'price_value_with_tax';
							if(!$discount_before_tax){
								$var = 'price_value';
							}

							if($coupon->discount_minimum_order>$total->prices[0]->$var){
								$error_message = JText::sprintf('ORDER_NOT_EXPENSIVE_ENOUGH_FOR_COUPON',$currency->format($coupon->discount_minimum_order,$coupon->discount_currency_id));
							}
						}
						if(empty($error_message) && $coupon->discount_minimum_products){
							if (!empty($coupon->discount_product_id)) {
								$qty=0;
								foreach ($products as $product) {
									$ok = false;
									if($product->product_id == $coupon->discount_product_id){
										$ok = true;
									}
									if(!$ok){
										foreach ($products as $product2) {
											if($product2->cart_product_id == $product->cart_product_parent_id && $product2->product_id == $coupon->discount_product_id){
												$ok = true;
											}
										}
									}
									if($ok){
										$qty+=$product->cart_product_quantity;
									}
								}
							}
							else if(!empty($id)) {
								$qty=0;
								foreach ($products as $product) {
									foreach ($id as $productid) {
										if (empty($coupon->discount_coupon_product_only) || !$product->cart_product_option_parent_id) {
											$ok = false;
											if($product->product_id == $productid[0]){
												$ok = true;
											}
											if(!$ok){
												foreach ($products as $product2) {
													if($product2->cart_product_id == $product->cart_product_parent_id && $product2->product_id == $productid[0]){
														$ok = true;
													}
												}
											}
											if($ok){
												$qty+=$product->cart_product_quantity;
											}
										}
									}
								}
							}
							if($coupon->discount_minimum_products>$qty){
								$error_message = JText::sprintf('NOT_ENOUGH_PRODUCTS_FOR_COUPON',$coupon->discount_minimum_products);
							}
						}
					}
				}
			}
		}
		$dispatcher->trigger( 'onAfterCouponCheck', array( &$coupon,&$total,&$zones,&$products,&$display_error, &$error_message, & $do));

		if(!empty($error_message)){


			$class = hikashop_get('class.cart');
			$class->update('',0,0,'coupon');
			if($display_error){
				JRequest::setVar('coupon_error_message',$error_message);
			}
			return null;
		}

		JRequest::setVar('coupon_error_message','');

		if($do){

			//convert the currency if needed
			$currency->convertCoupon($coupon,$total->prices[0]->price_currency_id);

			if(!HIKASHOP_PHP5){
				$coupon->total = $total;
			}else{
				$coupon->total->prices = array(clone(reset($total->prices)));
			}

/* Start BRAINFORGE */

// OLD		$currency->addCoupon($coupon->total,$coupon);
// OLD		return $coupon;
		// Changes for: 27448 Coupons for specific products
			$this->recalculateDiscountValue($coupon,$products,$id);

			// Changes for: 11199 Coupons and Discounts
			switch (@$coupon->discount_coupon_nodoubling) {
				case 1:
					// Coupon ignores discounted values
					// (1) product prices less discount (coupon ignored)
					// �100 product with 10% discount and 5% coupon - gives price of �90.		---------- OK
					// (2) product prices less coupon (no product discounts)
					// �100 product with 5% coupon - gives price of �95.						---------- OK
					// (3) product prices less discount and no coupon value
					// �100 product with 10% discount and 20% coupon - gives price of �90.		---------- OK
					// (4) product prices less discount and coupon value
					// �100 product with 10% discounts and 10% coupon - gives price of �90.		---------- OK
					$coupon = $this->addCoupon($coupon, $products, $currency, 1);
					break;
				case 2:
					// Coupon reduced by discounted values
					// (1) product prices less discount (coupon reduced)
					// �100 product with 10% discount and 5% coupon - gives price of �90.		---------- OK
					// (2) product prices less coupon (no product discounts)
					// �100 product with 5% coupon - gives price of �95.						---------- OK
					// (3) product prices less discount and reduced coupon value
					// �100 product with 10% discount and 20% coupon - gives price of �80.		---------- OK
					// (4) product prices less discount and coupon value
					// �100 product with 10% discounts and 10% coupon - gives price of �90.		---------- OK
					$coupon = $this->addCoupon($coupon, $products, $currency, 2);
					break;
				default:
					// Standard coupon behaviour
					// (1) product prices less discount and coupon value
					// �100 product with 10% discount and 5% coupon - gives price of �85.50.	---------- OK
					// (2) product prices less coupon (no product discounts)
					// �100 product with 5% coupon - gives price of �95.						---------- OK
					// (3) product prices less discount and coupon value
					// �100 product with 10% discount and 20% coupon - gives price of �72.		---------- OK
					// (4) product prices less discount and coupon value
					// �100 product with 10% discounts and 10% coupon - gives price of �81.		---------- OK
					$currency->addCoupon($coupon->total,$coupon, $products, $id);
					break;
			}
		}
		return $coupon;
	}

	function recalculateDiscountValue(&$coupon,&$products,&$id){

		if (!empty($coupon->discount_coupon_product_only) && bccomp($coupon->discount_percent_amount, 0, 5)) {
			$coupon->discount_flat_amount = 0;

			if (!empty($coupon->discount_product_id)) {
				// Voucher discount applies to single product only
				$variantsFirst = array_reverse($products);
				foreach ($variantsFirst as $product) {
					if(!isset($product->prices[0])) continue;
					if ($coupon->discount_product_id == $product->product_id || $product->product_parent_id == $coupon->discount_product_id) {
						switch($coupon->discount_coupon_nodoubling){
							case 2:
								if (isset($product->prices[0]->price_value_without_discount)){
									$coupon->discount_flat_amount += ($coupon->discount_percent_amount * $product->prices[0]->price_value) / 100;
									$coupon->discount_flat_amount-=$product->prices[0]->price_value_without_discount-$product->prices[0]->price_value;
									if($coupon->discount_flat_amount<0)$coupon->discount_flat_amount=0;
									continue;
								}
							case 1:
								if (isset($product->prices[0]->price_value_without_discount)){
									continue;
								}
							default:
								$coupon->discount_flat_amount += ($coupon->discount_percent_amount * $product->prices[0]->price_value) / 100;
								break;
						}
						break;
					}
				}
			}
			else if(!empty($id)) {
				// Voucher discount applies to products in category(ies)
				$variantsFirst = array_reverse($products);
				foreach ($variantsFirst as $product) {
					if(!isset($product->prices[0])) continue;
					foreach ($id as $productid) {
						if($product->product_id == $productid[0] && empty($product->variants) || $product->product_parent_id == $productid[0]) {
							switch($coupon->discount_coupon_nodoubling){
								case 2:
									if (isset($product->prices[0]->price_value_without_discount)){
										$coupon->discount_flat_amount += ($coupon->discount_percent_amount * $product->prices[0]->price_value) / 100;
										$coupon->discount_flat_amount-=$product->prices[0]->price_value_without_discount-$product->prices[0]->price_value;
										if($coupon->discount_flat_amount<0)$coupon->discount_flat_amount=0;
										continue;
									}
								case 1:
									if (isset($product->prices[0]->price_value_without_discount)){
										continue;
									}
								default:
									$coupon->discount_flat_amount += ($coupon->discount_percent_amount * $product->prices[0]->price_value) / 100;
									break;
							}
							break;
						}
					}
				}
			}

			if (bccomp($coupon->discount_flat_amount, 0, 5)) {
				$coupon->discount_percent_amount = 0;
				$coupon->discount_coupon_nodoubling = null;
			}
		}
	}


	function addCoupon(&$coupon1, &$products, &$currency, $discountmode) {
		// Calculate any discounts which apply
		$totaldiscount=0.0;
		$totaldiscount_with_tax=0.0;
		$totalprice=0.0;
		$totalprice_with_tax=0.0;
		$totalnondiscount=0.0;
		$totalnondiscount_with_tax=0.0;
		foreach($products as $k => $product){
			if(!empty($product->prices)&&$product->cart_product_quantity>0){
				$price = reset($product->prices);
				if (isset($price->price_value)) {
					$totalprice += $price->price_value;
					if (isset($price->price_value_without_discount)){
						$totaldiscount += $price->price_value_without_discount - $price->price_value;
					}
					else {
						$totalnondiscount += $price->price_value;
					}
				}
				if (isset($price->price_value_with_tax)) {
					$totalprice_with_tax += $price->price_value_with_tax;
					if (isset($price->price_value_without_discount_with_tax)){
						$totaldiscount_with_tax += $price->price_value_without_discount_with_tax - $price->price_value_with_tax;
					}
					else {
						$totalnondiscount_with_tax += $price->price_value_with_tax;
					}
				}
			}
		}

		if (!bccomp($totaldiscount_with_tax, 0, 5) || !bccomp($totaldiscount, 0, 5)) {
			// No product discounts, so proceed with default behaviour
			$currency->addCoupon($coupon1->total,$coupon1);
			return $coupon1;
		}

		if (bccomp($coupon1->discount_flat_amount, 0, 5) && $totalnondiscount >= $coupon1->discount_flat_amount) {
			// Sufficient non-discounted products, so proceed with default behaviour
			$currency->addCoupon($coupon1->total,$coupon1);
			return $coupon1;
		}

		$totalprice += $totaldiscount;
		$totalprice_with_tax += $totaldiscount_with_tax;

		// Get a copy of the coupon object and process it using $currency->addCoupon(...)
		$coupon2 = clone($coupon1);
		$coupon2->total = clone($coupon1->total);
		$coupon2->total->prices = $this->copyStandardPrices($coupon1->total->prices);
		switch ($discountmode) {
			case 2:
				// Coupon reduced by discounted values
				//$coupon2->total->prices[0]->price_value_without_discount_with_tax = $totalprice_with_tax;
				//$coupon2->total->prices[0]->price_value_without_discount = $totalprice;
				$coupon2->total->prices[0]->price_value_with_tax = $totalprice_with_tax;
				$coupon2->total->prices[0]->price_value = $totalprice;

				$currency->addCoupon($coupon2->total,$coupon2);

				$coupon2->total->prices[0]->price_value_without_discount_with_tax -= $totaldiscount_with_tax;
				$coupon2->total->prices[0]->price_value_without_discount -= $totaldiscount;
				$coupon2->discount_percent_amount_calculated_without_tax -= $totaldiscount;
				$coupon2->discount_value_without_tax -= $totaldiscount;
				$coupon2->discount_percent_amount_calculated -= $totaldiscount;
				$coupon2->discount_value -= $totaldiscount;
				$coupon2->discount_flat_amount = $coupon2->discount_value;
				break;
			default:
				// Coupon ignores discounted values
				//$coupon2->total->prices[0]->price_value_without_discount_with_tax = $totalnondiscount_with_tax;
				//$coupon2->total->prices[0]->price_value_without_discount = $totalnondiscount;
				//$coupon2->total->prices[0]->price_value_with_tax = $totalnondiscount_with_tax;
				//$coupon2->total->prices[0]->price_value = $totalnondiscount;
				if($coupon2->discount_flat_amount>$totalnondiscount_with_tax){
					$coupon2->discount_flat_amount=0;
				}
				$total = new stdClass();
				$obj= new stdClass();
				$total->prices = array($obj);
				$total->prices[0]->price_value_with_tax = $totalnondiscount_with_tax;
				$total->prices[0]->price_value = $totalnondiscount;
				$currency->addCoupon($total,$coupon2);
				break;
		}

		if (isset($coupon2->discount_percent_amount_calculated) && $discountmode < 2) {
			$price_diff = $coupon2->discount_percent_amount_calculated - $totaldiscount_with_tax;
			//switch ($discountmode) {
			//	case 2:
					// Coupon reduced by discounted values
			//		$price_diff += $totaldiscount;
			//		break;
			//	default:
					// Coupon ignores discounted values
			//		break;
			//}
		}
		elseif(isset($coupon2->discount_percent_amount_calculated) && $discountmode == 2){
			$price_diff = $coupon2->discount_value;
		}else if(isset($coupon2->discount_percent_amount_calculated) ){
			//$price_diff = $coupon2->discount_value - $totaldiscount_with_tax;
			$price_diff = $coupon2->discount_percent_amount_calculated - $totaldiscount_with_tax;
			$price_diff += $totaldiscount;
		}

		if (@$price_diff <= 0) {
			$couponErrorMessage = JText::_('COUPON_NO_VALUE_WHEN_DISCOUNT');
			JRequest::setVar('coupon_error_message',$couponErrorMessage);
			return $coupon1;
		}
		if(!(isset($coupon2->discount_percent_amount_calculated) && $discountmode == 2)){
			$coupon2->discount_percent_amount_calculated_without_tax = $price_diff + $totaldiscount;
			$coupon2->discount_value_without_tax = $price_diff + $totaldiscount;
			$coupon2->discount_percent_amount_calculated = $price_diff + $totaldiscount_with_tax;
			$coupon2->discount_value = $price_diff + $totaldiscount_with_tax;
		}
		if ($discountmode == 1) {
			// Coupon ignores discounted values
			$coupon2->total->prices[0]->price_value_without_discount_with_tax += ($totalprice_with_tax - $totalnondiscount_with_tax);
			$coupon2->total->prices[0]->price_value_without_discount += ($totalprice - $totalnondiscount);
			$coupon2->total->prices[0]->price_value_with_tax += ($totalprice_with_tax - $totalnondiscount_with_tax);
			$coupon2->total->prices[0]->price_value += ($totalprice - $totalnondiscount);
			$coupon2->total->prices[0]->price_value_with_tax -= $totaldiscount_with_tax;
			$coupon2->total->prices[0]->price_value -= $totaldiscount;
		}

		if ($coupon2->discount_flat_amount != $coupon2->discount_value_without_tax) {
			$couponErrorMessage = JText::_('COUPON_LIMITED_VALUE_WHEN_DISCOUNT');
			JRequest::setVar('coupon_error_message',$couponErrorMessage);
		}
		return $coupon2;
	}

	function copyStandardPrices($prices) {
		$copiedPrices = array();
		for ($i=0; $i<count($prices); $i++) $copiedPrices[$i] = clone($prices{$i});
		return $copiedPrices;

/* End BRAINFORGE */

	}
}